/*
 * LFNCall V 1.7
 *
 * Object Creater
 * (c) 1997-2001 Thomas Bohn, Vogelwiese 65, D-18435 Stralsund, Germany
 *
 */

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

'@Echo off'
'cls'
say''
say'     Ŀ'
say'                                  LFNCall V 1.7                         '
say'                            (c) Thomas Bohn 1997-2001                   '
say'                   LFN-Objekt erzeugen / Create LFN object              '
say'     '
say''

say 'Bitte whlen Sie die Sprache. / Please select your language.'
say ''
say '(D)eutsch'
say '(E)nglish'
say ''
pull Spr
say ''
say ''
if Spr="D" then say 'Geben Sie einen Titel fr das Objekt (z.B. XYZApp-LFN) ein:'
if Spr="E" then say 'Type in a title of the application (ex. XYZApp-LFN):'
say ''
parse pull title
say ''
if length(title) > 0 then do
 if Spr="D" then say 'Geben Sie das Kommando fr die Anwendung mit vollstndigem Pfad ein:'
 if Spr="E" then say 'Type in the command of the application with full path:'
 say ''
 parse pull command
 say ''
 if length(command) > 0 then do
  if Spr="D" then say 'Geben Sie den Dateityp (z.B. *.XYZ) ein:'
  if Spr="E" then say 'Type in the file type (ex. *.XYZ):'
  say ''
  pull filetype
  say ''
  if length(filtype) > 0 then do
   call ReadSetup 'LFNCALL.INI'
   Pfad = SetupVar('WinPath')
   Zaehler = SetupVar('CustApp')+1
   CustApp = 'CustApp'Zaehler
   assoc=SysIni( 'USER', 'PMWP_ASSOC_FILTER', filetype )
   Ende=length(assoc)-1
   assalt=substr(assoc,1,Ende)
   SysIni( 'USER', 'PMWP_ASSOC_FILTER', filetype, '00'x )
   classname = 'WPProgram'
   location = '<LFN_Folder>'
   setup = 'OBJECTID=<'title'>;EXENAME=LFN.EXE;STARTUPDIR='Pfad';MINWIN=HIDE;MINIMIZED=YES;PARAMETERS='command';ASSOCFILTER='filetype
   call SysCreateObject classname,title,location,setup,r
   call SysSleep 1
   assoc=SysIni( 'USER', 'PMWP_ASSOC_FILTER', filetype )
   Ende=length(assoc)-1
   assneu=substr(assoc,1,Ende)
   neutest=pos(assneu,assalt)
   if neutest <> 0 then assset = assalt || '00'x
   else assset = assneu || '00'x || assalt || '00'x
   Erg = SysIni( 'USER', 'PMWP_ASSOC_FILTER', filetype, assset )
   ok = SetupVar(CustApp,title)
   ok = SetupVar('CustApp',Zaehler)
   call WriteSetup
  end
 end
end
if Spr="D" then say 'Fertig.'
if Spr="E" then say 'Ready.'
say ''
exit

/* TSETUP for Rexx */
/* V 1.2 (24.3.01) */

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

/* Beispiel Benutzung:
call ReadSetup 'LFNCALL.INI'       INI-File einlesen
say SetupVar( 'Mode' )             Wert anzeigen
Var = SetupVar( 'Mode' )           Wert in Variable bernehmen
ok = SetupVar('Mode','move')       Wert setzen
ok = SetupVar('App3','/L')         Key lschen
call WriteSetup                    INI-File schreiben
*/

ReadSetup:
 SetupDatei = ARG(1)
 RSZ = 0
 do while lines(SetupDatei) <> 0
  RSZ = RSZ+1
  Zeile = linein(SetupDatei)
  RSW = pos('=',Zeile)
  if RSW <> 0 then do
   SetupKeys.RSZ = strip(substr(Zeile,1,RSW-1),'B')
   SetupStrings.RSZ = strip(substr(Zeile,RSW+1),'B')
  end
  else do
   SetupKeys.RSZ = strip(Zeile,'B')
   SetupStrings.RSZ = ''
  end
 end
 ok=stream(SetupDatei,'c','close')
 SetupKeys.0 = RSZ
 SetupStrings.0 = RSZ
return

SetupVar:
 Key = ARG(1)
 Inhalt = ARG(2)
 gefd = 0
 SVW = 0
 do SVZ = 1 to SetupKeys.0
  if gefd <> 1 then do
   if pos(translate(Key), translate(SetupKeys.SVZ)) == 1 then do
    if length(Key) == length(SetupKeys.SVZ) then do
     if Inhalt <> '' then do
      if translate(Inhalt) = '/L' then do
       SetupStrings.SVZ = ''
       SetupKeys.SVZ = '--/L--'
       SVW = SVW+1
      end
      else SetupStrings.SVZ = Inhalt
     end
     gefd = 1
     Ergebnis = strip( SetupStrings.SVZ, 'B' )
    end
   end
  end
 end
 Anzahl = SetupKeys.0-SVW
 if Inhalt <> '' then if gefd == 0 then do
  Anzahl = Anzahl+1
  SetupKeys.Anzahl = Key
  SetupStrings.Anzahl = Inhalt
  Ergebnis = strip( SetupStrings.Anzahl, 'B' )
 end
 SetupKeys.0=Anzahl
 SetupStrings.0=Anzahl
return Ergebnis

WriteSetup:
 WSZ = 0
 ok = SysFileDelete(SetupDatei)
 do while WSZ < SetupKeys.0
  WSZ=WSZ+1
  Zeile = SetupKeys.WSZ'='SetupStrings.WSZ
  if pos('SETUPKEYS',Zeile) == 0 then do
   if Zeile <> '=' then do
    if substr(Zeile,1,1) <> '[' then do
     if SetupKeys.WSZ <> '--/L--' then ok = lineout(SetupDatei,Zeile)
    end
    else ok = lineout(SetupDatei,SetupKeys.WSZ)
   end
   else ok = lineout(SetupDatei,'')
  end
 end
 ok=stream(SetupDatei,'c','close')
return
